package mac5855.app.controllers;

import java.io.IOException;
import java.util.Date;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import mac5855.app.dao.DAOFactory;
import mac5855.app.dao.UsuarioDAO;
import mac5855.app.models.Usuario;

/**
 * Servlet Filter implementation class AuthenticationFilter
 */
public class AuthenticationFilter implements Filter {

	public static String USER_KEY = "User";
	
	public static String USER_TYPE = "UserType";

	public static String FIELD_USER = "username";

	public static String FIELD_PASSWORD = "password";
	/**
	 * Default constructor. 
	 */
	private FilterConfig filterConfig = null;

	public void init(FilterConfig filterConfig) 
	throws ServletException {
		this.filterConfig = filterConfig;
	}
	public void destroy() {
		this.filterConfig = null;
	}


	/**
	 * @see Filter#doFilter(ServletRequest, ServletResponse, FilterChain)
	 */
	public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {
		long today = 0;
		HttpSession session = ((HttpServletRequest) request).getSession();
		String user = (String) session.getAttribute(USER_KEY);
		String tipo = (String) session.getAttribute(USER_TYPE);
		RequestDispatcher rd = request.getRequestDispatcher("/");

		if (user == null || tipo == null) {
			String username = request.getParameter(FIELD_USER);
			String password = request.getParameter(FIELD_PASSWORD);
			String last_logon = request.getParameter("last_logon");
			if(last_logon != null)
				today = Long.parseLong(last_logon);
			/* usuário vindo da tela de Login*/
			if((username != null && password != null) && ( username.length() > 0 )) {
				Usuario usuario = validUser(username, password);
				if(usuario != null ) {
					if(today > usuario.getUltimoLogin().getTime()) {
						usuario.setUltimoLogin(new Date(today));
						UsuarioDAO usuarioDAO = DAOFactory.getDAOFactory(DAOFactory.JDBC).getUsuarioDAO();
						usuarioDAO.updateLastLogon(usuario);
						session.setAttribute(USER_KEY, usuario.getEmail());
						session.setAttribute(USER_TYPE, usuario.getTipo());
						rd = request.getRequestDispatcher("/restricted/home.jsp");
						rd.forward(request, response);
						return;
					}
					else  
						request.setAttribute("Error", "Session has ended.  Please login.");


				}
				else //Password does not match, i.e., invalid user password
					request.setAttribute("Error", "Invalid password.");


			}
			/* usuário redirecionado para tela de Login */
			rd.forward(request, response);
			return;
		}
		chain.doFilter(request, response);

	}

	protected Usuario validUser(String username, String password) {


		UsuarioDAO usuarioDAO = DAOFactory.getDAOFactory(DAOFactory.JDBC).getUsuarioDAO();

		if ((username != null) && (username.length() > 0)) {
			Usuario userFind = new Usuario();
			userFind.setEmail(username);
			userFind.setSenha(password);
			Usuario usuario = usuarioDAO.find(userFind);
			if (usuario != null) {
				return usuario;
			}

		}

		return null;
	}

}
