package mac5855.app.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import mac5855.app.models.Categoria;
import mac5855.app.models.Usuario;

public class JdbcCategoriaDAO implements CategoriaDAO {

	@Override
	public void create(Categoria newInstance) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void delete(Integer id) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public Categoria find(Categoria object) {
		
		Connection conn = JdbcDAOFactory.createConnection();
		Categoria categoria = null;
		try {
			PreparedStatement stmt = conn.prepareStatement("select * from categorias where id = ?");
			stmt.setInt(1, object.getId());
			ResultSet rs = stmt.executeQuery();
			if (rs.next()) { //Query only returns 1 record in the result set; only 1 
				categoria = new Categoria();
				categoria.setId(rs.getInt("id"));
				categoria.setNome(rs.getString("nome"));
			}
			rs.close();
			stmt.close();

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		JdbcDAOFactory.releaseConnection(conn);

		return categoria;
	}

	@Override
	public Categoria[] findAll() {
		Connection conn = JdbcDAOFactory.createConnection();
		List<Categoria> categorias = new ArrayList<Categoria>();
		try {
			PreparedStatement stmt = conn.prepareStatement("select * from categorias");
			ResultSet rs = stmt.executeQuery();


			while (rs.next()) {
				// criando o objeto Contato
				Categoria categoria = new Categoria();
				categoria.setId(rs.getInt("id"));
				categoria.setNome(rs.getString("nome"));

				// adicionando o objeto à lista
				categorias.add(categoria);
			}

			rs.close();
			stmt.close();
		}
		catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		JdbcDAOFactory.releaseConnection(conn);

		return categorias.toArray(new Categoria[categorias.size()]);
	}

	@Override
	public void update(Categoria transientObject) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public Categoria findById(Integer id) {
		Connection conn = JdbcDAOFactory.createConnection();
		Categoria categoria = null;
		try {
			PreparedStatement stmt = conn.prepareStatement("select * from categorias where id = ?");
			stmt.setInt(1, id);
			ResultSet rs = stmt.executeQuery();


			if (rs.next()) {
				// criando o objeto Contato
				categoria = new Categoria();
				categoria.setId(rs.getInt("id"));
				categoria.setNome(rs.getString("nome"));
			
			}
			rs.close();
			stmt.close();
			
			
			
		}
		catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		JdbcDAOFactory.releaseConnection(conn);

		return categoria;
	}



}
